/*
 * restrict_thread_drv driver -
 *
 *  Copyright 2010 Sony Corporation.
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License as
 *	published by the Free Software Foundation, version 2.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __REST_THREAD_IF_H__
#define __REST_THREAD_IF_H__


#define DEF_REST_THD_NO_RESTRICT    2
#define DEF_REST_THD_SET_FORCE_STOP 1
#define DEF_REST_THD_CLEAR_ALL      0

#define DEF_REST_THD_DEBUG_TYPE_CLEAR 0
#define DEF_REST_THD_DEBUG_TYPE_SET   1


typedef struct ST_REST_THD_SET_TIME{
    unsigned long active_limit_jif; /*If thread spends this jif, restrict this thread.*/
    unsigned long restrict_reset_jif; /*If it takes this jif, clear to restrict.*/
} rest_thd_set_time_t;


typedef struct ST_REST_THD_INFO{
    pid_t pid; /*process pid*/
    rest_thd_set_time_t rest_time; /* time( jiffies )*/
    int priority;
} rest_thd_info_t;

typedef struct ST_REST_THD_DEBUG_INFO{
    int type;
    rest_thd_set_time_t rest_time; /* time( jiffies )*/
    unsigned long search_thread_group_jif;
    int priority;
} rest_thd_debug_info_t;


#define REST_THD_IOC_MAGIC 'a'
#define REST_THD_SET_INFO _IOW( REST_THD_IOC_MAGIC, 1, rest_thd_info_t )
#define REST_THD_CLEAR_INFO _IOW( REST_THD_IOC_MAGIC, 2, int )
#define REST_THD_DEBUG_PRINT_LIST _IOW( REST_THD_IOC_MAGIC, 3, int )
#define REST_THD_SET_LOG_LEVEL _IOW( REST_THD_IOC_MAGIC, 4, int )
#define REST_THD_SET_MODE _IOW( REST_THD_IOC_MAGIC, 5, int )
#define REST_THD_SET_DEBUG_PARAM _IOW( REST_THD_IOC_MAGIC, 6, rest_thd_debug_info_t )

/*temporary*/

#define MAJOR_REST_THD 254
#define MINOR_REST_THD 0

#define DEF_REST_THD_DEV_PATH "/dev/restrict_thread"

#endif /*__REST_THREAD_IF_H__*/
